; Theorarm library
; Copyright (C) 2009 Robin Watts for Pinknoise Productions Ltd

	AREA	|.text|, CODE, READONLY

	EXPORT	oc_frag_recon_inter2
	EXPORT	oc_frag_recon_inter
	EXPORT	oc_frag_recon_intra
	;EXPORT	oc_frag_copy
	EXPORT	oc_frag_copy_list

	IMPORT	oc_frag_copy_slow

oc_frag_copy_list
	; r0 = dst_frame_data
	; r1 = src_frame_data
	; r2 = ystride
	; r3 = nfragis
	; <> = fragis
	; <> = frag_buf_offs
	STMFD	r13!,{r4-r6,r11,r14}

	SUBS	r3, r3, #1
	BLT	ofcl_end
	LDR	r12,[r13,#4*5]		; r12 = fragis
	LDR	r14,[r13,#4*6]		; r14 = frag_buf_offs
	SUB	r2, r2, #4
ofcl_lp
	LDR	r11,[r12],#4		; r11 = fragis[fragii]
	; Stall (2 on Xscale)
	LDR	r11,[r14,r11,LSL #2]	; r11 = frag_buf_offs[fragis[fragii]]
	SUBS	r3, r3, #1
	; Stall (on XScale)
	ADD	r4, r1, r11		; r4 = src_frame_data+frag_buf_off

	LDR	r6, [r4], #4
	ADD	r11,r0, r11		; r11= dst_frame_data+frag_buf_off
	LDR	r5, [r4], r2
	STR	r6, [r11],#4
	LDR	r6, [r4], #4
	STR	r5, [r11],r2
	LDR	r5, [r4], r2
	STR	r6, [r11],#4
	LDR	r6, [r4], #4
	STR	r5, [r11],r2
	LDR	r5, [r4], r2
	STR	r6, [r11],#4
	LDR	r6, [r4], #4
	STR	r5, [r11],r2
	LDR	r5, [r4], r2
	STR	r6, [r11],#4
	LDR	r6, [r4], #4
	STR	r5, [r11],r2
	LDR	r5, [r4], r2
	STR	r6, [r11],#4
	LDR	r6, [r4], #4
	STR	r5, [r11],r2
	LDR	r5, [r4], r2
	STR	r6, [r11],#4
	LDR	r6, [r4], #4
	STR	r5, [r11],r2
	LDR	r5, [r4], r2
	STR	r6, [r11],#4
	LDR	r6, [r4], #4
	LDR	r4, [r4]
	STR	r5, [r11],r2
	STR	r6, [r11],#4
	STR	r4, [r11]
	BGE	ofcl_lp
ofcl_end
	LDMFD	r13!,{r4-r6,r11,PC}

 [ 0 = 1
oc_frag_copy
	; r0 = unsigned char *dst
	; r1 = unsigned char *src
	; r2 = ystride
	TST	r0, #3
	TSTNE	r1, #3
	BNE	oc_frag_copy_slow

	LDR	r3, [r1], #4
	SUB	r2, r2, #4
	LDR	r12,[r1], r2
	STR	r3, [r0], #4
	LDR	r3, [r1], #4
	STR	r12,[r0], r2
	LDR	r12,[r1], r2
	STR	r3, [r0], #4
	LDR	r3, [r1], #4
	STR	r12,[r0], r2
	LDR	r12,[r1], r2
	STR	r3, [r0], #4
	LDR	r3, [r1], #4
	STR	r12,[r0], r2
	LDR	r12,[r1], r2
	STR	r3, [r0], #4
	LDR	r3, [r1], #4
	STR	r12,[r0], r2
	LDR	r12,[r1], r2
	STR	r3, [r0], #4
	LDR	r3, [r1], #4
	STR	r12,[r0], r2
	LDR	r12,[r1], r2
	STR	r3, [r0], #4
	LDR	r3, [r1], #4
	STR	r12,[r0], r2
	LDR	r12,[r1], r2
	STR	r3, [r0], #4
	LDR	r3, [r1], #4
	LDR	r1, [r1]
	STR	r12,[r0], r2
	STR	r3, [r0], #4
	STR	r1, [r0]

	MOV	PC,r14
 ]
oc_frag_recon_intra
	; r0 =       unsigned char *dst
	; r1 =       int            ystride
	; r2 = const ogg_int16_t    residue[64]
	STMFD	r13!,{r4,r5,r14}

	MOV	r14,#8
	MOV	r5, #255
	SUB	r1, r1, #7
ofrintra_lp
	LDRSH	r3, [r2], #2
	LDRSH	r4, [r2], #2
	LDRSH	r12,[r2], #2
	ADDS	r3, r3, #128
	CMPGT	r5, r3
	EORLT	r3, r5, r3, ASR #32
	STRB	r3, [r0], #1
	ADDS	r4, r4, #128
	CMPGT	r5, r4
	EORLT	r4, r5, r4, ASR #32
	LDRSH	r3, [r2], #2
	STRB	r4, [r0], #1
	ADDS	r12,r12,#128
	CMPGT	r5, r12
	EORLT	r12,r5, r12,ASR #32
	LDRSH	r4, [r2], #2
	STRB	r12,[r0], #1
	ADDS	r3, r3, #128
	CMPGT	r5, r3
	EORLT	r3, r5, r3, ASR #32
	LDRSH	r12,[r2], #2
	STRB	r3, [r0], #1
	ADDS	r4, r4, #128
	CMPGT	r5, r4
	EORLT	r4, r5, r4, ASR #32
	LDRSH	r3, [r2], #2
	STRB	r4, [r0], #1
	ADDS	r12,r12,#128
	CMPGT	r5, r12
	EORLT	r12,r5, r12,ASR #32
	LDRSH	r4, [r2], #2
	STRB	r12,[r0], #1
	ADDS	r3, r3, #128
	CMPGT	r5, r3
	EORLT	r3, r5, r3, ASR #32
	STRB	r3, [r0], #1
	ADDS	r4, r4, #128
	CMPGT	r5, r4
	EORLT	r4, r5, r4, ASR #32
	STRB	r4, [r0], r1
	SUBS	r14,r14,#1
	BGT	ofrintra_lp

	LDMFD	r13!,{r4,r5,PC}

oc_frag_recon_inter
	; r0 =       unsigned char *dst
	; r1 = const unsigned char *src
	; r2 =       int            ystride
	; r3 = const ogg_int16_t    residue[64]
	STMFD	r13!,{r5,r9-r11,r14}

	MOV	r9, #8
	MOV	r5, #255
	SUB	r2, r2, #7
ofrinter_lp
	LDRSH	r12,[r3], #2
	LDRB	r14,[r1], #1
	LDRSH	r11,[r3], #2
	LDRB	r10,[r1], #1
	ADDS	r12,r12,r14
	CMPGT	r5, r12
	EORLT	r12,r5, r12,ASR #32
	STRB	r12,[r0], #1
	ADDS	r11,r11,r10
	CMPGT	r5, r11
	LDRSH	r12,[r3], #2
	LDRB	r14,[r1], #1
	EORLT	r11,r5, r11,ASR #32
	STRB	r11,[r0], #1
	ADDS	r12,r12,r14
	CMPGT	r5, r12
	LDRSH	r11,[r3], #2
	LDRB	r10,[r1], #1
	EORLT	r12,r5, r12,ASR #32
	STRB	r12,[r0], #1
	ADDS	r11,r11,r10
	CMPGT	r5, r11
	LDRSH	r12,[r3], #2
	LDRB	r14,[r1], #1
	EORLT	r11,r5, r11,ASR #32
	STRB	r11,[r0], #1
	ADDS	r12,r12,r14
	CMPGT	r5, r12
	LDRSH	r11,[r3], #2
	LDRB	r10,[r1], #1
	EORLT	r12,r5, r12,ASR #32
	STRB	r12,[r0], #1
	ADDS	r11,r11,r10
	CMPGT	r5, r11
	LDRSH	r12,[r3], #2
	LDRB	r14,[r1], #1
	EORLT	r11,r5, r11,ASR #32
	STRB	r11,[r0], #1
	ADDS	r12,r12,r14
	CMPGT	r5, r12
	LDRSH	r11,[r3], #2
	LDRB	r10,[r1], r2
	EORLT	r12,r5, r12,ASR #32
	STRB	r12,[r0], #1
	ADDS	r11,r11,r10
	CMPGT	r5, r11
	EORLT	r11,r5, r11,ASR #32
	STRB	r11,[r0], r2
	SUBS	r9, r9, #1
	BGT	ofrinter_lp

	LDMFD	r13!,{r5,r9-r11,PC}

oc_frag_recon_inter2
	; r0 =       unsigned char *dst
	; r1 = const unsigned char *src1
	; r2 = const unsigned char *src2
	; r3 =       int            ystride
	LDR	r12,[r13]
	; r12= const ogg_int16_t    residue[64]
	STMFD	r13!,{r4-r8,r14}

	MOV	r14,#8
	MOV	r8, #255
	SUB	r3, r3, #7
ofrinter2_lp
	LDRB	r5, [r1], #1
	LDRB	r6, [r2], #1
 	LDRSH	r4, [r12],#2
	LDRB	r7, [r1], #1
	ADD	r5, r5, r6
	ADDS	r5, r4, r5, LSR #1
	CMPGT	r8, r5
	LDRB	r6, [r2], #1
 	LDRSH	r4, [r12],#2
	EORLT	r5, r8, r5, ASR #32
	STRB	r5, [r0], #1

	ADD	r7, r7, r6
	ADDS	r7, r4, r7, LSR #1
	CMPGT	r8, r7
	LDRB	r5, [r1], #1
	LDRB	r6, [r2], #1
 	LDRSH	r4, [r12],#2
	EORLT	r7, r8, r7, ASR #32
	STRB	r7, [r0], #1

	ADD	r5, r5, r6
	ADDS	r5, r4, r5, LSR #1
	CMPGT	r8, r5
	LDRB	r7, [r1], #1
	LDRB	r6, [r2], #1
 	LDRSH	r4, [r12],#2
	EORLT	r5, r8, r5, ASR #32
	STRB	r5, [r0], #1

	ADD	r7, r7, r6
	ADDS	r7, r4, r7, LSR #1
	CMPGT	r8, r7
	LDRB	r5, [r1], #1
	LDRB	r6, [r2], #1
 	LDRSH	r4, [r12],#2
	EORLT	r7, r8, r7, ASR #32
	STRB	r7, [r0], #1

	ADD	r5, r5, r6
	ADDS	r5, r4, r5, LSR #1
	CMPGT	r8, r5
	LDRB	r7, [r1], #1
	LDRB	r6, [r2], #1
 	LDRSH	r4, [r12],#2
	EORLT	r5, r8, r5, ASR #32
	STRB	r5, [r0], #1

	ADD	r7, r7, r6
	ADDS	r7, r4, r7, LSR #1
	CMPGT	r8, r7
	LDRB	r5, [r1], #1
	LDRB	r6, [r2], #1
 	LDRSH	r4, [r12],#2
	EORLT	r7, r8, r7, ASR #32
	STRB	r7, [r0], #1

	ADD	r5, r5, r6
	ADDS	r5, r4, r5, LSR #1
	CMPGT	r8, r5
	LDRB	r7, [r1], r3
	LDRB	r6, [r2], r3
 	LDRSH	r4, [r12],#2
	EORLT	r5, r8, r5, ASR #32
	STRB	r5, [r0], #1

	ADD	r7, r7, r6
	ADDS	r7, r4, r7, LSR #1
	CMPGT	r8, r7
	EORLT	r7, r8, r7, ASR #32
	STRB	r7, [r0], r3

	SUBS	r14,r14,#1
	BGT	ofrinter2_lp

	LDMFD	r13!,{r4-r8,PC}

	END
