; Theorarm library
; Copyright (C) 2009 Robin Watts for Pinknoise Productions Ltd

	AREA	|.text|, CODE, READONLY

	EXPORT	loop_filter_h
	EXPORT	loop_filter_v
	EXPORT	oc_state_loop_filter_frag_rows_inner

loop_filter_h
	; r0 = unsigned char *pix
	; r1 = int            ystride
	; r2 = int           *bv
	; preserves r0-r3
	STMFD	r13!,{r3-r6,r14}

	MOV	r14,#8
	MOV	r6, #255
lfh_lp
	LDRB	r3, [r0, #-2]		; r3 = pix[0]
	LDRB	r12,[r0, #1]		; r12= pix[3]
	LDRB	r4, [r0, #-1]		; r4 = pix[1]
	LDRB	r5, [r0]		; r5 = pix[2]
	SUB	r3, r3, r12		; r3 = pix[0]-pix[3]+4
	ADD	r3, r3, #4
	SUB	r12,r5, r4		; r12= pix[2]-pix[1]
	ADD	r12,r12,r12,LSL #1	; r12= 3*(pix[2]-pix[1])
	ADD	r12,r12,r3	; r12= pix[0]-pix[3]+3*(pix[2]-pix[1])+4
 [ 1 = 1
	MOV	r12,r12,ASR #3
	LDRSB	r12,[r2, r12]
	; Stall (2 on Xscale)
 |
	MOVS	r12,r12,ASR #3
	ADDLE	r3, r2, r12
	SUBGT	r3, r2, r12		; r3 = 2F-|f|
	BIC	r3, r3, r3, ASR #32	; r3 = MAX(2F-|f|, 0)
	CMP	r3, r12			; if (r3 < r12)
	MOVLT	r12,r3			;   r12=r3   r12=MIN(r12,r3)
	CMN	r3, r12			; if (-r3 < r12)
	RSBLT	r12,r3, #0		;   r12=-r3
 ]
	ADDS	r4, r4, r12
	CMPGT	r6, r4
	EORLT	r4, r6, r4, ASR #32
	SUBS	r5, r5, r12
	CMPGT	r6, r5
	EORLT	r5, r6, r5, ASR #32
	STRB	r4, [r0, #-1]
	STRB	r5, [r0], r1
	SUBS	r14,r14,#1
	BGT	lfh_lp
	SUB	r0, r0, r1, LSL #3

	LDMFD	r13!,{r3-r6,PC}

loop_filter_v
	; r0 = unsigned char *pix
	; r1 = int            ystride
	; r2 = int           *bv
	; preserves r0-r3
	STMFD	r13!,{r3-r6,r14}

	MOV	r14,#8
	MOV	r6, #255
lfv_lp
	LDRB	r3, [r0, -r1, LSL #1]	; r3 = pix[0]
	LDRB	r12,[r0, r1]		; r12= pix[3]
	LDRB	r4, [r0, -r1]		; r4 = pix[1]
	LDRB	r5, [r0]		; r5 = pix[2]
	SUB	r3, r3, r12		; r3 = pix[0]-pix[3]+4
	ADD	r3, r3, #4
	SUB	r12,r5, r4		; r12= pix[2]-pix[1]
	ADD	r12,r12,r12,LSL #1	; r12= 3*(pix[2]-pix[1])
	ADD	r12,r12,r3	; r12= pix[0]-pix[3]+3*(pix[2]-pix[1])+4
 [ 1 = 1
	MOV	r12,r12,ASR #3
	LDRSB	r12,[r2, r12]
	; Stall (2 on Xscale)
 |
	MOVS	r12,r12,ASR #3
	ADDLE	r3, r2, r12
	SUBGT	r3, r2, r12		; r3 = 2F-|f|
	BIC	r3, r3, r3, ASR #32	; r3 = MAX(2F-|f|, 0)
	CMP	r3, r12			; if (r3 < r12)
	MOVLT	r12,r3			;   r12=r3   r12=MIN(r12,r3)
	CMN	r3, r12			; if (-r3 < r12)
	RSBLT	r12,r3, #0		;   r12=-r3
 ]
	ADDS	r4, r4, r12
	CMPGT	r6, r4
	EORLT	r4, r6, r4, ASR #32
	SUBS	r5, r5, r12
	CMPGT	r6, r5
	EORLT	r5, r6, r5, ASR #32
	STRB	r4, [r0, -r1]
	STRB	r5, [r0], #1
	SUBS	r14,r14,#1
	BGT	lfv_lp

	SUB	r0, r0, #8

	LDMFD	r13!,{r3-r6,PC}

; Which bit this is depends on the order of packing within a bitfield.
CODED	*	1

oc_state_loop_filter_frag_rows_inner
	; r0 = ref_frame_data
	; r1 = ystride
	; r2 = bv
	; r3 = frags
	; r4 = fragi0
	; r5 = fragi0_end
	; r6 = fragi_top
	; r7 = fragi_bot
	; r8 = frag_buf_offs
	; r9 = nhfrags
	MOV	r12,r13
	STMFD	r13!,{r0,r4-r11,r14}
	LDMFD	r12,{r4-r9}

	CMP	r4, r5		; if(fragi0>=fragi0_end)
	BGE	oslffri_end	;   bale
	SUBS	r9, r9, #1	; r9 = nhfrags-1	if (r9<=0)
	BLE	oslffri_end	;			  bale
	ADD	r3, r3, r4, LSL #2	; r3 = &frags[fragi]
	ADD	r8, r8, r4, LSL #2	; r8 = &frag_buf_oggs[fragi]
	SUB	r7, r7, r9	; fragi_bot -= nfrags;
oslffri_lp1
	MOV	r10,r4		; r10= fragi = fragi0
	ADD	r11,r4, r9	; r11= fragi_end-1=fragi+nfrags-1
oslffri_lp2
	LDR	r14,[r3], #4	; r14= frags[fragi]	frags++
	LDR	r0, [r13]	; r0 = ref_frame_data
	LDR	r12,[r8], #4	; r12= frag_buf_offs[fragi]   frag_buf_offs++
	TST	r14,#CODED
	BEQ	oslffri_uncoded
	CMP	r10,r4		; if (fragi>fragi0)
	ADD	r0, r0, r12	; r0 = ref_frame_data + frag_buf_offs[fragi]
	BLGT	loop_filter_h
	CMP	r4, r6		; if (fragi0>fragi_top)
	BLGT	loop_filter_v
	CMP	r10,r11		; if(fragi+1<fragi_end)===(fragi<fragi_end-1)
	LDRLT	r12,[r3]	; r12 = frags[fragi+1]
	ADD	r0, r0, #8
	ADD	r10,r10,#1	; r10 = fragi+1;
	ANDLT	r12,r12,#CODED
	CMPLT	r12,#CODED	; && frags[fragi+1].coded==0
	BLLT	loop_filter_h
	CMP	r10,r7		; if (fragi<fragi_bot)
	LDRLT	r12,[r3, r9, LSL #2]	; r12 = frags[fragi+1+nhfrags-1]
	SUB	r0, r0, #8
	ADD	r0, r0, r1, LSL #3
	ANDLT	r12,r12,#CODED
	CMPLT	r12,#CODED
	BLLT	loop_filter_v

	CMP	r10,r11		; while(fragi<=fragiend-1)
	BLE	oslffri_lp2
	MOV	r4, r10		; r4 = fragi0 += nhfrags
	CMP	r4, r5
	BLT	oslffri_lp1

oslffri_end
	LDMFD	r13!,{r0,r4-r11,PC}
oslffri_uncoded
	ADD	r10,r10,#1
	CMP	r10,r11
	BLE	oslffri_lp2
	MOV	r4, r10		; r4 = fragi0 += nhfrags
	CMP	r4, r5
	BLT	oslffri_lp1

	LDMFD	r13!,{r0,r4-r11,PC}

	END
